Index: branches/CMAES/HeuristicLab.Algorithms.CMAEvolutionStrategy/3.3/HeuristicLab.Algorithms.CMAEvolutionStrategy-3.3.csproj
===================================================================
--- branches/CMAES/HeuristicLab.Algorithms.CMAEvolutionStrategy/3.3/HeuristicLab.Algorithms.CMAEvolutionStrategy-3.3.csproj	(revision 9149)
+++ branches/CMAES/HeuristicLab.Algorithms.CMAEvolutionStrategy/3.3/HeuristicLab.Algorithms.CMAEvolutionStrategy-3.3.csproj	(revision 9155)
@@ -118,9 +118,4 @@
       <Private>False</Private>
     </Reference>
-    <Reference Include="HeuristicLab.Encodings.RealVectorEncoding-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Encodings.RealVectorEncoding-3.3.dll</HintPath>
-      <Private>False</Private>
-    </Reference>
     <Reference Include="HeuristicLab.Operators-3.3">
       <SpecificVersion>False</SpecificVersion>
@@ -222,4 +217,9 @@
       <Project>{887425b4-4348-49ed-a457-b7d2c26ddbf9}</Project>
       <Name>HeuristicLab.Analysis-3.3</Name>
+      <Private>False</Private>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Encodings.RealVectorEncoding\3.3\HeuristicLab.Encodings.RealVectorEncoding-3.3.csproj">
+      <Project>{bb6d334a-4bb6-4674-9883-31a6ebb32cab}</Project>
+      <Name>HeuristicLab.Encodings.RealVectorEncoding-3.3</Name>
       <Private>False</Private>
     </ProjectReference>
Index: branches/CMAES/HeuristicLab.Analysis.Views/3.3/HeuristicLab.Analysis.Views-3.3.csproj
===================================================================
--- branches/CMAES/HeuristicLab.Analysis.Views/3.3/HeuristicLab.Analysis.Views-3.3.csproj	(revision 9149)
+++ branches/CMAES/HeuristicLab.Analysis.Views/3.3/HeuristicLab.Analysis.Views-3.3.csproj	(revision 9155)
@@ -184,14 +184,20 @@
       <DependentUpon>ScatterPlotDataRowVisualPropertiesControl.cs</DependentUpon>
     </Compile>
-    <Compile Include="ScatterPlotView.cs" />
+    <Compile Include="ScatterPlotView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
     <Compile Include="ScatterPlotView.Designer.cs">
       <DependentUpon>ScatterPlotView.cs</DependentUpon>
     </Compile>
-    <Compile Include="ScatterPlotHistoryView.cs" />
+    <Compile Include="ScatterPlotHistoryView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
     <Compile Include="ScatterPlotHistoryView.Designer.cs">
       <DependentUpon>ScatterPlotHistoryView.cs</DependentUpon>
     </Compile>
     <None Include="Plugin.cs.frame" />
-    <Compile Include="AlleleFrequencyCollectionView.cs" />
+    <Compile Include="AlleleFrequencyCollectionView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
     <Compile Include="AlleleFrequencyCollectionView.Designer.cs">
       <DependentUpon>AlleleFrequencyCollectionView.cs</DependentUpon>
@@ -215,21 +221,31 @@
       <DependentUpon>DataTableVisualPropertiesDialog.cs</DependentUpon>
     </Compile>
-    <Compile Include="HeatMapHistoryView.cs" />
+    <Compile Include="HeatMapHistoryView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
     <Compile Include="HeatMapHistoryView.Designer.cs">
       <DependentUpon>HeatMapHistoryView.cs</DependentUpon>
     </Compile>
-    <Compile Include="DataTableHistoryView.cs" />
+    <Compile Include="DataTableHistoryView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
     <Compile Include="DataTableHistoryView.Designer.cs">
       <DependentUpon>DataTableHistoryView.cs</DependentUpon>
     </Compile>
-    <Compile Include="HeatMapView.cs" />
+    <Compile Include="HeatMapView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
     <Compile Include="HeatMapView.Designer.cs">
       <DependentUpon>HeatMapView.cs</DependentUpon>
     </Compile>
-    <Compile Include="AlleleFrequencyView.cs" />
+    <Compile Include="AlleleFrequencyView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
     <Compile Include="AlleleFrequencyView.Designer.cs">
       <DependentUpon>AlleleFrequencyView.cs</DependentUpon>
     </Compile>
-    <Compile Include="AlleleFrequencyCollectionHistoryView.cs" />
+    <Compile Include="AlleleFrequencyCollectionHistoryView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
     <Compile Include="AlleleFrequencyCollectionHistoryView.Designer.cs">
       <DependentUpon>AlleleFrequencyCollectionHistoryView.cs</DependentUpon>
@@ -237,5 +253,7 @@
     <Compile Include="Plugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="DataTableView.cs" />
+    <Compile Include="DataTableView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
     <Compile Include="DataTableView.Designer.cs">
       <DependentUpon>DataTableView.cs</DependentUpon>
@@ -245,11 +263,4 @@
     <None Include="HeuristicLab.snk" />
     <None Include="Properties\AssemblyInfo.cs.frame" />
-  </ItemGroup>
-  <ItemGroup>
-    <ProjectReference Include="..\..\HeuristicLab.Analysis\3.3\HeuristicLab.Analysis-3.3.csproj">
-      <Project>{887425B4-4348-49ED-A457-B7D2C26DDBF9}</Project>
-      <Name>HeuristicLab.Analysis-3.3</Name>
-      <Private>False</Private>
-    </ProjectReference>
   </ItemGroup>
   <ItemGroup>
@@ -274,4 +285,11 @@
       <DependentUpon>HeatMapView.cs</DependentUpon>
     </EmbeddedResource>
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Analysis\3.3\HeuristicLab.Analysis-3.3.csproj">
+      <Project>{887425b4-4348-49ed-a457-b7d2c26ddbf9}</Project>
+      <Name>HeuristicLab.Analysis-3.3</Name>
+      <Private>False</Private>
+    </ProjectReference>
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: branches/CMAES/HeuristicLab.Encodings.RealVectorEncoding/3.3/HeuristicLab.Encodings.RealVectorEncoding-3.3.csproj
===================================================================
--- branches/CMAES/HeuristicLab.Encodings.RealVectorEncoding/3.3/HeuristicLab.Encodings.RealVectorEncoding-3.3.csproj	(revision 9149)
+++ branches/CMAES/HeuristicLab.Encodings.RealVectorEncoding/3.3/HeuristicLab.Encodings.RealVectorEncoding-3.3.csproj	(revision 9155)
@@ -168,5 +168,5 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="Creators\PredefinedRealVectorCreator.cs" />
+    <Compile Include="Creators\NormalDistributedRealVectorCreator.cs" />
     <Compile Include="Interfaces\IRealVectorMultiNeighborhoodShakingOperator.cs" />
     <Compile Include="ParticleOperators\RealVectorParticleCreator.cs" />