Index: branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/HeuristicLab.Encodings.ConditionActionEncoding-3.3.csproj
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/HeuristicLab.Encodings.ConditionActionEncoding-3.3.csproj	(revision 9154)
+++ branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/HeuristicLab.Encodings.ConditionActionEncoding-3.3.csproj	(revision 9160)
@@ -68,4 +68,5 @@
       <Private>False</Private>
     </Reference>
+    <Reference Include="HeuristicLab.Problems.Instances-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
     <Reference Include="HeuristicLab.Selection-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
       <Private>False</Private>
@@ -120,4 +121,5 @@
     <Compile Include="Selectors\IMatchSelector.cs" />
     <Compile Include="Selectors\MatchSelector.cs" />
+    <Compile Include="Selectors\PreservingRightReducer.cs" />
     <Compile Include="Subsumption\ActionSetSubsumptionOperator.cs" />
     <Compile Include="Subsumption\CheckGASubsumptionOperator.cs" />
Index: branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Interfaces/IConditionActionProblemData.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Interfaces/IConditionActionProblemData.cs	(revision 9154)
+++ branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Interfaces/IConditionActionProblemData.cs	(revision 9160)
@@ -34,8 +34,4 @@
     IEnumerable<string> AllowedActionVariables { get; }
 
-    IntValue Length { get; }
-    IntValue ActionLength { get; }
-    IntMatrix Bounds { get; }
-
     IClassifier FetchClassifier(int rowNumber);
 
Index: branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Selectors/PreservingRightReducer.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Selectors/PreservingRightReducer.cs	(revision 9160)
+++ branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Selectors/PreservingRightReducer.cs	(revision 9160)
@@ -0,0 +1,58 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Selection;
+
+namespace HeuristicLab.Encodings.ConditionActionEncoding {
+  [Item("PreservingRightReducer", "")]
+  [StorableClass]
+  public sealed class PreservingRightReducer : Reducer, IReducer {
+    [StorableConstructor]
+    private PreservingRightReducer(bool deserializing) : base(deserializing) { }
+    private PreservingRightReducer(PreservingRightReducer original, Cloner cloner) : base(original, cloner) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PreservingRightReducer(this, cloner);
+    }
+    public PreservingRightReducer() : base() { }
+
+    protected override List<IScope> Reduce(List<IScope> scopes) {
+      IScope rightChild = scopes[scopes.Count - 1];
+      IScope leftChild = scopes[0];
+
+      if (rightChild.SubScopes.Count != 1) {
+        throw new ArgumentException("Right child is only allowed to have one sub scope");
+      }
+
+      foreach (var variable in rightChild.SubScopes[0].Variables) {
+        CurrentScope.Variables.Add(new Variable(variable.Name, variable.Value));
+      }
+
+      return leftChild.SubScopes.ToList();
+    }
+  }
+}